#include "MAX30100_PulseOximeter.h"
#include "application.h"
#define REPORTING_PERIOD_MS     10
#define slaveAddress 0x5A

#include <MPU6050.h>
#include "application.h"
SYSTEM_MODE(AUTOMATIC);
SYSTEM_THREAD(ENABLED);
// PulseOximeter is the higher level interface to the sensor
// it offers:
//  * beat detection reporting
//  * heart rate calculation
//  * SpO2 (oxidation level) calculation
PulseOximeter pox;
int BPM,sp;
float t;
uint32_t tsLastReport = 0;
uint32_t tsLastReport1 = 0;
MPU6050 accelgyro;
int16_t ax, ay, az;
int16_t gx, gy, gz;
int  x;
int  y;
int  z;

// Callback (registered below) fired when a pulse is detected
void onBeatDetected()
{
    Serial.println("Beat!");
}

void setup()
{

    Serial.begin(9600);
    Serial1.begin(9600);
    // Initialize the PulseOximeter instance and register a beat-detected callback
    pox.begin();
    pox.setOnBeatDetectedCallback(onBeatDetected);
    
    Serial.println("Initializing I2C devices...");
    accelgyro.initialize();

    // Cerify the connection:
    Serial.println("Testing device connections...");
    Serial.println(accelgyro.testConnection() ? "MPU6050 connection successful" : "MPU6050 connection failed");
    
    ////////////
    
    //Particle.subscribe("Health", myHandler1, ALL_DEVICES);
    //Particle.subscribe("ang", myHandler2, ALL_DEVICES);
     
    //Mesh.subscribe("Health", myHandler1);
    //Mesh.subscribe("ang", myHandler2);
    
    
    /////////////
    
}


//////////////////////////////////////////////////////
/*
void myHandler1(const char *event, const char *data){
    String new_data = String(data);
    Serial.println("\t"); 
    Serial.print("Heart rate:");
    Serial.print(data);
   
}
void myHandler2(const char *event, const char *data){
    String new_data = String(data);
    
  
    digitalWrite(D7,0);
    Serial.println("\t"); 
    Serial.print("acc");
    Serial.print(data);
   
}
*/
//////////////////////////////////////////////////////

void loop()
{
pox.update();
BPM=pox.getHeartRate();
sp=pox.getSpO2();
 accelgyro.getMotion6(&ax, &ay, &az, &gx, &gy, &gz);

////////////////////////////

Serial.println(" ");

Serial.print("\t"); 
Serial.print("Heart rate:");
Serial.print(BPM);

Serial.print("\t");
Serial.print("bpm / SpO2:");
Serial.print(sp);
Serial.print("% ");


///////////////////hc 05

Serial1.println(" ");

Serial1.print("\t"); 
Serial1.print("Heart rate:");
Serial1.print(BPM);

Serial1.print("\t");
Serial1.print("bpm / SpO2:");
Serial1.print(sp);
Serial1.print("% ");

////////////////////////hc05

    
    
//////////////////////////////////////////////
 
 /*
 
  Serial.print("\t");
  Serial.print("ax value ");
  Serial.print(ax);
  
  Serial.print("\t");
  Serial.print("ay value ");
  Serial.print(ay);
  
  Serial.print("\t");
  Serial.print("az value ");
  Serial.print(az);
  
  
  Serial.print("\t");
  Serial.print("gx value ");
  Serial.print(gx);
  
  Serial.print("\t");
  Serial.print("gy value ");
  Serial.print(gy);
  
  Serial.print("\t");
  Serial.print("gz value ");
  Serial.print(gz);
  
  
  */
////////////////////////////////////////////
/////////////////////////////////hc05

  Serial1.print("\t");
  Serial1.print("ax value ");
  Serial1.print(ax);
  
  Serial1.print("\t");
  Serial1.print("ay value ");
  Serial1.print(ay);
  
  Serial1.print("\t");
  Serial1.print("az value ");
  Serial1.print(az);
  
  
  Serial1.print("\t");
  Serial1.print("gx value ");
  Serial1.print(gx);
  
  Serial1.print("\t");
  Serial1.print("gy value ");
  Serial1.print(gy);
  
  Serial1.print("\t");
  Serial1.print("gz value ");
  Serial1.print(gz);

/////////////////////////////////////////hc05

x=(map(ax,-15972,15972,0,360));
y=(map(ay,-15972,15972,0,360));
z=(map(az,-15972,15972,0,360));


/*
  Serial.print("\t");
  Serial.print("x angle ");
  Serial.print(x);
  
  Serial.print("\t");
  Serial.print("y angle ");
  Serial.print(y);
  
  Serial.print("\t");
  Serial.print("z angle ");
  Serial.print(z);
  
  
  */
//////////////////////////////////////////hc05

  Serial1.print("\t");
  Serial1.print("x angle ");
  Serial1.print(x);
  
  Serial1.print("\t");
  Serial1.print("y angle ");
  Serial1.print(y);
  
  Serial1.print("\t");
  Serial1.print("z angle ");
  Serial1.print(z);



//////////////////////////////////////////hc05
  
  
  
////////////////////////////////////////////////
/*
Mesh.publish("Health", String(BPM)+"bpm="+String(sp)+"%"+String(t)+"C");
Mesh.publish("ang", String(x)+"x "+"y="+String(y)+"z = "+ String(z));
Mesh.publish("acc", String(ax)+"=x"+String(ay)+"=y"+String(az)+"=z");
  
  */  
/////////////////////////////////////////////////    
// Particle.publish("BPM",  String(BPM)+"BPM");
// Particle.publish("spo2",  String(sp)+"%");   
//Particle.publish("BPM", String(BPM));
//Particle.publish("spo2", String(sp));
//Particle.publish("temp", String(t)); 
    
///////////////////////////////////////////    
if (millis() - tsLastReport1 > 1000) {
Particle.publish("Health", String(BPM)+"bpm "+"spo2="+String(sp)+"%  "+"temp="+String(t)+"C");
Particle.publish("ang", String(x)+"=x "+"...y="+String(y)+"..z="+ String(z));
Particle.publish("acc", String(ax)+"=x"+String(ay)+"..y="+"...z="+String(az));
tsLastReport1 = millis();
}
//////////////////////////////
/*  
if (millis() - tsLastReport1 > 1000) {
Particle.publish("BPM", String(BPM)+"bpm");
Particle.publish("spo2", String(sp));
Particle.publish("temp", String(t));
tsLastReport1 = millis();
}*/

}
